CREATE TABLE `{prefix}_{dirname}_ability` (
  `ability_id` smallint(5) unsigned NOT NULL auto_increment,
  `ability_name` varchar(50) NOT NULL,
  `description` varchar(255) NOT NULL,
  `ability_cost` tinyint(4) NOT NULL,
  `can_upgrade` tinyint(3) unsigned NOT NULL,
  `upgrade` varchar(255) NOT NULL,
  `register_time` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`ability_id`),
  UNIQUE KEY `ability_name` (`ability_name`)
) ENGINE=MyISAM;

CREATE TABLE `{prefix}_{dirname}_char` (
  `eno` smallint(5) unsigned NOT NULL,
  `full_name` varchar(255) NOT NULL,
  PRIMARY KEY  (`eno`)
) ENGINE=MyISAM;

CREATE TABLE `{prefix}_{dirname}_costume` (
  `costume_id` tinyint(3) unsigned NOT NULL auto_increment,
  `costume_name` varchar(50) NOT NULL,
  `grow_life` tinyint(4) NOT NULL,
  `grow_soul` tinyint(4) NOT NULL,
  `grow_pow` tinyint(4) NOT NULL,
  `grow_str` tinyint(4) NOT NULL,
  `grow_dex` tinyint(4) NOT NULL,
  `grow_speed` tinyint(4) NOT NULL,
  `grow_mag` tinyint(4) NOT NULL,
  `grow_reg` tinyint(4) NOT NULL,
  `grow_con` tinyint(4) NOT NULL,
  `modify_hp` tinyint(4) NOT NULL,
  `modify_at` tinyint(4) NOT NULL,
  `modify_df` tinyint(4) NOT NULL,
  `modify_mat` tinyint(4) NOT NULL,
  `modify_mdf` tinyint(4) NOT NULL,
  `modify_hit` tinyint(4) NOT NULL,
  `modify_con` tinyint(4) NOT NULL,
  `modify_act` tinyint(4) NOT NULL,
  `modify_avoid` tinyint(4) NOT NULL,
  `move_cost` tinyint(3) unsigned NOT NULL,
  `register_time` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`costume_id`)
) ENGINE=MyISAM;

CREATE TABLE `{prefix}_{dirname}_kind` (
  `kind_id` tinyint(3) unsigned NOT NULL auto_increment,
  `kind_name` varchar(20) NOT NULL,
  PRIMARY KEY  (`kind_id`)
) ENGINE=MyISAM;

CREATE TABLE `{prefix}_{dirname}_skill` (
  `skill_id` smallint(5) unsigned NOT NULL auto_increment,
  `skill_name` varchar(50) NOT NULL,
  `description` varchar(255) NOT NULL,
  `range` tinyint(4) NOT NULL,
  `target_id` tinyint(3) unsigned NOT NULL,
  `kind_id` tinyint(3) unsigned NOT NULL,
  `tp` smallint(5) unsigned NOT NULL,
  `register_time` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`skill_id`)
) ENGINE=MyISAM;

CREATE TABLE `{prefix}_{dirname}_skill_element` (
  `skill_id` smallint(5) unsigned NOT NULL,
  `element_id` tinyint(4) NOT NULL,
  PRIMARY KEY  (`skill_id`,`element_id`)
) ENGINE=MyISAM;

CREATE TABLE `{prefix}_{dirname}_target` (
  `target_id` tinyint(3) unsigned NOT NULL auto_increment,
  `target_name` varchar(10) NOT NULL,
  PRIMARY KEY  (`target_id`)
) ENGINE=MyISAM;

CREATE TABLE `{prefix}_{dirname}_update` (
  `update_time` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`update_time`)
) ENGINE=MyISAM;
